
/* : : generated by proto : : */
/*******************************************************************
*                                                                  *
*             This software is part of the ast package             *
*                Copyright (c) 1998-2001 AT&T Corp.                *
*        and it may only be used by you under license from         *
*                       AT&T Corp. ("AT&T")                        *
*         A copy of the Source Code Agreement is available         *
*                at the AT&T Internet web site URL                 *
*                                                                  *
*       http://www.research.att.com/sw/license/ast-open.html       *
*                                                                  *
*        If you have copied this software without agreeing         *
*        to the terms of the license you are infringing on         *
*           the license and copyright and are violating            *
*               AT&T's intellectual property rights.               *
*                                                                  *
*                 This software was created by the                 *
*                 Network Services Research Center                 *
*                        AT&T Labs Research                        *
*                         Florham Park NJ                          *
*                                                                  *
*               Glenn Fowler <gsf@research.att.com>                *
*******************************************************************/
                  
/*
 * uu encode/decode interface definitions
 *
 * AT&T Research
 */

#ifndef _UU_H
#if !defined(__PROTO__)
#include <prototyped.h>
#endif

#define _UU_H

#include <ast.h>

#define UU_VERSION	19980611L

#define UU_HEADER	(1<<0)		/* header/trailer encoded too	*/
#define UU_TEXT		(1<<1)		/* process text file		*/

struct Uu_s; typedef struct Uu_s Uu_t;
struct Uudisc_s; typedef struct Uudisc_s Uudisc_t;
struct Uumeth_s; typedef struct Uumeth_s Uumeth_t;

typedef int (*Uu_f) __PROTO__((Uu_t*));
typedef int (*Uuerror_f) __PROTO__((Uu_t*, Uudisc_t*, int, const char*, ...));

struct Uumeth_s
{
	const char*	name;
	const char*	alias;
	const char*	id;
	Uu_f		headerf;
	Uu_f		encodef;
	Uu_f		decodef;
	__V_*		data;
};

struct Uudisc_s
{
	unsigned long	version;
	unsigned long	flags;
	Uuerror_f	errorf;
};

struct Uu_s
{
	const char*	id;
	Uumeth_t	meth;
	Uudisc_t*	disc;
	char*		path;

#ifdef _UU_PRIVATE_
	_UU_PRIVATE_
#endif

};

#if _BLD_uu && defined(__EXPORT__)
#define extern		__EXPORT__
#endif

extern __MANGLE__ Uu_t*		uuopen __PROTO__((Uudisc_t*, Uumeth_t*));
extern __MANGLE__ int		uuclose __PROTO__((Uu_t*));

extern __MANGLE__ ssize_t		uuencode __PROTO__((Uu_t*, Sfio_t*, Sfio_t*, size_t, const char*));
extern __MANGLE__ ssize_t		uudecode __PROTO__((Uu_t*, Sfio_t*, Sfio_t*, size_t, const char*));

extern __MANGLE__ int		uumain __PROTO__((char**, int));

extern __MANGLE__ int		uulist __PROTO__((Sfio_t*));
extern __MANGLE__ Uumeth_t*	uumeth __PROTO__((const char*));

#undef	extern

#endif
